<?php

// Data functions (insert, update, delete, form) for table enrollment

// This script and data application were generated by AppGini 5.62
// Download AppGini for free from https://bigprof.com/appgini/download/

function enrollment_insert(){
	global $Translation;

	// mm: can member insert record?
	$arrPerm=getTablePermissions('enrollment');
	if(!$arrPerm[1]){
		return false;
	}

	$data['stud_id'] = makeSafe($_REQUEST['stud_id']);
		if($data['stud_id'] == empty_lookup_value){ $data['stud_id'] = ''; }
	$data['course_id'] = makeSafe($_REQUEST['course_id']);
		if($data['course_id'] == empty_lookup_value){ $data['course_id'] = ''; }
	$data['score'] = makeSafe($_REQUEST['score']);
		if($data['score'] == empty_lookup_value){ $data['score'] = ''; }
	$data['notes'] = makeSafe($_REQUEST['notes']);
		if($data['notes'] == empty_lookup_value){ $data['notes'] = ''; }
	$data['certificate_notes'] = makeSafe($_REQUEST['certificate_notes']);
		if($data['certificate_notes'] == empty_lookup_value){ $data['certificate_notes'] = ''; }

	// hook: enrollment_before_insert
	if(function_exists('enrollment_before_insert')){
		$args=array();
		if(!enrollment_before_insert($data, getMemberInfo(), $args)){ return false; }
	}

	$o = array('silentErrors' => true);
	sql('insert into `enrollment` set       `stud_id`=' . (($data['stud_id'] !== '' && $data['stud_id'] !== NULL) ? "'{$data['stud_id']}'" : 'NULL') . ', `course_id`=' . (($data['course_id'] !== '' && $data['course_id'] !== NULL) ? "'{$data['course_id']}'" : 'NULL') . ', `score`=' . (($data['score'] !== '' && $data['score'] !== NULL) ? "'{$data['score']}'" : 'NULL') . ', `notes`=' . (($data['notes'] !== '' && $data['notes'] !== NULL) ? "'{$data['notes']}'" : 'NULL') . ', `certificate_notes`=' . (($data['certificate_notes'] !== '' && $data['certificate_notes'] !== NULL) ? "'{$data['certificate_notes']}'" : 'NULL'), $o);
	if($o['error']!=''){
		echo $o['error'];
		echo "<a href=\"enrollment_view.php?addNew_x=1\">{$Translation['< back']}</a>";
		exit;
	}

	$recID = db_insert_id(db_link());

	// hook: enrollment_after_insert
	if(function_exists('enrollment_after_insert')){
		$res = sql("select * from `enrollment` where `rec_id`='" . makeSafe($recID, false) . "' limit 1", $eo);
		if($row = db_fetch_assoc($res)){
			$data = array_map('makeSafe', $row);
		}
		$data['selectedID'] = makeSafe($recID, false);
		$args=array();
		if(!enrollment_after_insert($data, getMemberInfo(), $args)){ return $recID; }
	}

	// mm: save ownership data
	sql("insert ignore into membership_userrecords set tableName='enrollment', pkValue='" . makeSafe($recID, false) . "', memberID='" . makeSafe(getLoggedMemberID(), false) . "', dateAdded='" . time() . "', dateUpdated='" . time() . "', groupID='" . getLoggedGroupID() . "'", $eo);

	return $recID;
}

function enrollment_delete($selected_id, $AllowDeleteOfParents=false, $skipChecks=false){
	// insure referential integrity ...
	global $Translation;
	$selected_id=makeSafe($selected_id);

	// mm: can member delete record?
	$arrPerm=getTablePermissions('enrollment');
	$ownerGroupID=sqlValue("select groupID from membership_userrecords where tableName='enrollment' and pkValue='$selected_id'");
	$ownerMemberID=sqlValue("select lcase(memberID) from membership_userrecords where tableName='enrollment' and pkValue='$selected_id'");
	if(($arrPerm[4]==1 && $ownerMemberID==getLoggedMemberID()) || ($arrPerm[4]==2 && $ownerGroupID==getLoggedGroupID()) || $arrPerm[4]==3){ // allow delete?
		// delete allowed, so continue ...
	}else{
		return $Translation['You don\'t have enough permissions to delete this record'];
	}

	// hook: enrollment_before_delete
	if(function_exists('enrollment_before_delete')){
		$args=array();
		if(!enrollment_before_delete($selected_id, $skipChecks, getMemberInfo(), $args))
			return $Translation['Couldn\'t delete this record'];
	}

	// child table: attendance
	$res = sql("select `rec_id` from `enrollment` where `rec_id`='$selected_id'", $eo);
	$rec_id = db_fetch_row($res);
	$rires = sql("select count(1) from `attendance` where `student_course`='".addslashes($rec_id[0])."'", $eo);
	$rirow = db_fetch_row($rires);
	if($rirow[0] && !$AllowDeleteOfParents && !$skipChecks){
		$RetMsg = $Translation["couldn't delete"];
		$RetMsg = str_replace("<RelatedRecords>", $rirow[0], $RetMsg);
		$RetMsg = str_replace("<TableName>", "attendance", $RetMsg);
		return $RetMsg;
	}elseif($rirow[0] && $AllowDeleteOfParents && !$skipChecks){
		$RetMsg = $Translation["confirm delete"];
		$RetMsg = str_replace("<RelatedRecords>", $rirow[0], $RetMsg);
		$RetMsg = str_replace("<TableName>", "attendance", $RetMsg);
		$RetMsg = str_replace("<Delete>", "<input type=\"button\" class=\"button\" value=\"".$Translation['yes']."\" onClick=\"window.location='enrollment_view.php?SelectedID=".urlencode($selected_id)."&delete_x=1&confirmed=1';\">", $RetMsg);
		$RetMsg = str_replace("<Cancel>", "<input type=\"button\" class=\"button\" value=\"".$Translation['no']."\" onClick=\"window.location='enrollment_view.php?SelectedID=".urlencode($selected_id)."';\">", $RetMsg);
		return $RetMsg;
	}

	sql("delete from `enrollment` where `rec_id`='$selected_id'", $eo);

	// hook: enrollment_after_delete
	if(function_exists('enrollment_after_delete')){
		$args=array();
		enrollment_after_delete($selected_id, getMemberInfo(), $args);
	}

	// mm: delete ownership data
	sql("delete from membership_userrecords where tableName='enrollment' and pkValue='$selected_id'", $eo);
}

function enrollment_update($selected_id){
	global $Translation;

	// mm: can member edit record?
	$arrPerm=getTablePermissions('enrollment');
	$ownerGroupID=sqlValue("select groupID from membership_userrecords where tableName='enrollment' and pkValue='".makeSafe($selected_id)."'");
	$ownerMemberID=sqlValue("select lcase(memberID) from membership_userrecords where tableName='enrollment' and pkValue='".makeSafe($selected_id)."'");
	if(($arrPerm[3]==1 && $ownerMemberID==getLoggedMemberID()) || ($arrPerm[3]==2 && $ownerGroupID==getLoggedGroupID()) || $arrPerm[3]==3){ // allow update?
		// update allowed, so continue ...
	}else{
		return false;
	}

	$data['stud_id'] = makeSafe($_REQUEST['stud_id']);
		if($data['stud_id'] == empty_lookup_value){ $data['stud_id'] = ''; }
	$data['course_id'] = makeSafe($_REQUEST['course_id']);
		if($data['course_id'] == empty_lookup_value){ $data['course_id'] = ''; }
	$data['score'] = makeSafe($_REQUEST['score']);
		if($data['score'] == empty_lookup_value){ $data['score'] = ''; }
	$data['notes'] = makeSafe($_REQUEST['notes']);
		if($data['notes'] == empty_lookup_value){ $data['notes'] = ''; }
	$data['certificate_notes'] = makeSafe($_REQUEST['certificate_notes']);
		if($data['certificate_notes'] == empty_lookup_value){ $data['certificate_notes'] = ''; }
	$data['selectedID']=makeSafe($selected_id);

	// hook: enrollment_before_update
	if(function_exists('enrollment_before_update')){
		$args=array();
		if(!enrollment_before_update($data, getMemberInfo(), $args)){ return false; }
	}

	$o=array('silentErrors' => true);
	sql('update `enrollment` set       `stud_id`=' . (($data['stud_id'] !== '' && $data['stud_id'] !== NULL) ? "'{$data['stud_id']}'" : 'NULL') . ', `course_id`=' . (($data['course_id'] !== '' && $data['course_id'] !== NULL) ? "'{$data['course_id']}'" : 'NULL') . ', `score`=' . (($data['score'] !== '' && $data['score'] !== NULL) ? "'{$data['score']}'" : 'NULL') . ', `notes`=' . (($data['notes'] !== '' && $data['notes'] !== NULL) ? "'{$data['notes']}'" : 'NULL') . ', `certificate_notes`=' . (($data['certificate_notes'] !== '' && $data['certificate_notes'] !== NULL) ? "'{$data['certificate_notes']}'" : 'NULL') . " where `rec_id`='".makeSafe($selected_id)."'", $o);
	if($o['error']!=''){
		echo $o['error'];
		echo '<a href="enrollment_view.php?SelectedID='.urlencode($selected_id)."\">{$Translation['< back']}</a>";
		exit;
	}


	// hook: enrollment_after_update
	if(function_exists('enrollment_after_update')){
		$res = sql("SELECT * FROM `enrollment` WHERE `rec_id`='{$data['selectedID']}' LIMIT 1", $eo);
		if($row = db_fetch_assoc($res)){
			$data = array_map('makeSafe', $row);
		}
		$data['selectedID'] = $data['rec_id'];
		$args = array();
		if(!enrollment_after_update($data, getMemberInfo(), $args)){ return; }
	}

	// mm: update ownership data
	sql("update membership_userrecords set dateUpdated='".time()."' where tableName='enrollment' and pkValue='".makeSafe($selected_id)."'", $eo);

}

function enrollment_form($selected_id = '', $AllowUpdate = 1, $AllowInsert = 1, $AllowDelete = 1, $ShowCancel = 0, $TemplateDV = '', $TemplateDVP = ''){
	// function to return an editable form for a table records
	// and fill it with data of record whose ID is $selected_id. If $selected_id
	// is empty, an empty form is shown, with only an 'Add New'
	// button displayed.

	global $Translation;

	// mm: get table permissions
	$arrPerm=getTablePermissions('enrollment');
	if(!$arrPerm[1] && $selected_id==''){ return ''; }
	$AllowInsert = ($arrPerm[1] ? true : false);
	// print preview?
	$dvprint = false;
	if($selected_id && $_REQUEST['dvprint_x'] != ''){
		$dvprint = true;
	}

	$filterer_stud_id = thisOr(undo_magic_quotes($_REQUEST['filterer_stud_id']), '');
	$filterer_course_id = thisOr(undo_magic_quotes($_REQUEST['filterer_course_id']), '');

	// populate filterers, starting from children to grand-parents

	// unique random identifier
	$rnd1 = ($dvprint ? rand(1000000, 9999999) : '');
	// combobox: stud_id
	$combo_stud_id = new DataCombo;
	// combobox: course_id
	$combo_course_id = new DataCombo;

	if($selected_id){
		// mm: check member permissions
		if(!$arrPerm[2]){
			return "";
		}
		// mm: who is the owner?
		$ownerGroupID=sqlValue("select groupID from membership_userrecords where tableName='enrollment' and pkValue='".makeSafe($selected_id)."'");
		$ownerMemberID=sqlValue("select lcase(memberID) from membership_userrecords where tableName='enrollment' and pkValue='".makeSafe($selected_id)."'");
		if($arrPerm[2]==1 && getLoggedMemberID()!=$ownerMemberID){
			return "";
		}
		if($arrPerm[2]==2 && getLoggedGroupID()!=$ownerGroupID){
			return "";
		}

		// can edit?
		if(($arrPerm[3]==1 && $ownerMemberID==getLoggedMemberID()) || ($arrPerm[3]==2 && $ownerGroupID==getLoggedGroupID()) || $arrPerm[3]==3){
			$AllowUpdate=1;
		}else{
			$AllowUpdate=0;
		}

		$res = sql("select * from `enrollment` where `rec_id`='".makeSafe($selected_id)."'", $eo);
		if(!($row = db_fetch_array($res))){
			return error_message($Translation['No records found'], 'enrollment_view.php', false);
		}
		$urow = $row; /* unsanitized data */
		$hc = new CI_Input();
		$row = $hc->xss_clean($row); /* sanitize data */
		$combo_stud_id->SelectedData = $row['stud_id'];
		$combo_course_id->SelectedData = $row['course_id'];
	}else{
		$combo_stud_id->SelectedData = $filterer_stud_id;
		$combo_course_id->SelectedData = $filterer_course_id;
	}
	$combo_stud_id->HTML = '<span id="stud_id-container' . $rnd1 . '"></span><input type="hidden" name="stud_id" id="stud_id' . $rnd1 . '" value="' . html_attr($combo_stud_id->SelectedData) . '">';
	$combo_stud_id->MatchText = '<span id="stud_id-container-readonly' . $rnd1 . '"></span><input type="hidden" name="stud_id" id="stud_id' . $rnd1 . '" value="' . html_attr($combo_stud_id->SelectedData) . '">';
	$combo_course_id->HTML = '<span id="course_id-container' . $rnd1 . '"></span><input type="hidden" name="course_id" id="course_id' . $rnd1 . '" value="' . html_attr($combo_course_id->SelectedData) . '">';
	$combo_course_id->MatchText = '<span id="course_id-container-readonly' . $rnd1 . '"></span><input type="hidden" name="course_id" id="course_id' . $rnd1 . '" value="' . html_attr($combo_course_id->SelectedData) . '">';

	ob_start();
	?>

	<script>
		// initial lookup values
		AppGini.current_stud_id__RAND__ = { text: "", value: "<?php echo addslashes($selected_id ? $urow['stud_id'] : $filterer_stud_id); ?>"};
		AppGini.current_course_id__RAND__ = { text: "", value: "<?php echo addslashes($selected_id ? $urow['course_id'] : $filterer_course_id); ?>"};

		jQuery(function() {
			setTimeout(function(){
				if(typeof(stud_id_reload__RAND__) == 'function') stud_id_reload__RAND__();
				if(typeof(course_id_reload__RAND__) == 'function') course_id_reload__RAND__();
			}, 10); /* we need to slightly delay client-side execution of the above code to allow AppGini.ajaxCache to work */
		});
		function stud_id_reload__RAND__(){
		<?php if(($AllowUpdate || $AllowInsert) && !$dvprint){ ?>

			$j("#stud_id-container__RAND__").select2({
				/* initial default value */
				initSelection: function(e, c){
					$j.ajax({
						url: 'ajax_combo.php',
						dataType: 'json',
						data: { id: AppGini.current_stud_id__RAND__.value, t: 'enrollment', f: 'stud_id' },
						success: function(resp){
							c({
								id: resp.results[0].id,
								text: resp.results[0].text
							});
							$j('[name="stud_id"]').val(resp.results[0].id);
							$j('[id=stud_id-container-readonly__RAND__]').html('<span id="stud_id-match-text">' + resp.results[0].text + '</span>');
							if(resp.results[0].id == '<?php echo empty_lookup_value; ?>'){ $j('.btn[id=students_view_parent]').hide(); }else{ $j('.btn[id=students_view_parent]').show(); }


							if(typeof(stud_id_update_autofills__RAND__) == 'function') stud_id_update_autofills__RAND__();
						}
					});
				},
				width: ($j('fieldset .col-xs-11').width() - select2_max_width_decrement()) + 'px',
				formatNoMatches: function(term){ return '<?php echo addslashes($Translation['No matches found!']); ?>'; },
				minimumResultsForSearch: 10,
				loadMorePadding: 200,
				ajax: {
					url: 'ajax_combo.php',
					dataType: 'json',
					cache: true,
					data: function(term, page){ return { s: term, p: page, t: 'enrollment', f: 'stud_id' }; },
					results: function(resp, page){ return resp; }
				},
				escapeMarkup: function(str){ return str; }
			}).on('change', function(e){
				AppGini.current_stud_id__RAND__.value = e.added.id;
				AppGini.current_stud_id__RAND__.text = e.added.text;
				$j('[name="stud_id"]').val(e.added.id);
				if(e.added.id == '<?php echo empty_lookup_value; ?>'){ $j('.btn[id=students_view_parent]').hide(); }else{ $j('.btn[id=students_view_parent]').show(); }


				if(typeof(stud_id_update_autofills__RAND__) == 'function') stud_id_update_autofills__RAND__();
			});

			if(!$j("#stud_id-container__RAND__").length){
				$j.ajax({
					url: 'ajax_combo.php',
					dataType: 'json',
					data: { id: AppGini.current_stud_id__RAND__.value, t: 'enrollment', f: 'stud_id' },
					success: function(resp){
						$j('[name="stud_id"]').val(resp.results[0].id);
						$j('[id=stud_id-container-readonly__RAND__]').html('<span id="stud_id-match-text">' + resp.results[0].text + '</span>');
						if(resp.results[0].id == '<?php echo empty_lookup_value; ?>'){ $j('.btn[id=students_view_parent]').hide(); }else{ $j('.btn[id=students_view_parent]').show(); }

						if(typeof(stud_id_update_autofills__RAND__) == 'function') stud_id_update_autofills__RAND__();
					}
				});
			}

		<?php }else{ ?>

			$j.ajax({
				url: 'ajax_combo.php',
				dataType: 'json',
				data: { id: AppGini.current_stud_id__RAND__.value, t: 'enrollment', f: 'stud_id' },
				success: function(resp){
					$j('[id=stud_id-container__RAND__], [id=stud_id-container-readonly__RAND__]').html('<span id="stud_id-match-text">' + resp.results[0].text + '</span>');
					if(resp.results[0].id == '<?php echo empty_lookup_value; ?>'){ $j('.btn[id=students_view_parent]').hide(); }else{ $j('.btn[id=students_view_parent]').show(); }

					if(typeof(stud_id_update_autofills__RAND__) == 'function') stud_id_update_autofills__RAND__();
				}
			});
		<?php } ?>

		}
		function course_id_reload__RAND__(){
		<?php if(($AllowUpdate || $AllowInsert) && !$dvprint){ ?>

			$j("#course_id-container__RAND__").select2({
				/* initial default value */
				initSelection: function(e, c){
					$j.ajax({
						url: 'ajax_combo.php',
						dataType: 'json',
						data: { id: AppGini.current_course_id__RAND__.value, t: 'enrollment', f: 'course_id' },
						success: function(resp){
							c({
								id: resp.results[0].id,
								text: resp.results[0].text
							});
							$j('[name="course_id"]').val(resp.results[0].id);
							$j('[id=course_id-container-readonly__RAND__]').html('<span id="course_id-match-text">' + resp.results[0].text + '</span>');
							if(resp.results[0].id == '<?php echo empty_lookup_value; ?>'){ $j('.btn[id=courses_view_parent]').hide(); }else{ $j('.btn[id=courses_view_parent]').show(); }


							if(typeof(course_id_update_autofills__RAND__) == 'function') course_id_update_autofills__RAND__();
						}
					});
				},
				width: ($j('fieldset .col-xs-11').width() - select2_max_width_decrement()) + 'px',
				formatNoMatches: function(term){ return '<?php echo addslashes($Translation['No matches found!']); ?>'; },
				minimumResultsForSearch: 10,
				loadMorePadding: 200,
				ajax: {
					url: 'ajax_combo.php',
					dataType: 'json',
					cache: true,
					data: function(term, page){ return { s: term, p: page, t: 'enrollment', f: 'course_id' }; },
					results: function(resp, page){ return resp; }
				},
				escapeMarkup: function(str){ return str; }
			}).on('change', function(e){
				AppGini.current_course_id__RAND__.value = e.added.id;
				AppGini.current_course_id__RAND__.text = e.added.text;
				$j('[name="course_id"]').val(e.added.id);
				if(e.added.id == '<?php echo empty_lookup_value; ?>'){ $j('.btn[id=courses_view_parent]').hide(); }else{ $j('.btn[id=courses_view_parent]').show(); }


				if(typeof(course_id_update_autofills__RAND__) == 'function') course_id_update_autofills__RAND__();
			});

			if(!$j("#course_id-container__RAND__").length){
				$j.ajax({
					url: 'ajax_combo.php',
					dataType: 'json',
					data: { id: AppGini.current_course_id__RAND__.value, t: 'enrollment', f: 'course_id' },
					success: function(resp){
						$j('[name="course_id"]').val(resp.results[0].id);
						$j('[id=course_id-container-readonly__RAND__]').html('<span id="course_id-match-text">' + resp.results[0].text + '</span>');
						if(resp.results[0].id == '<?php echo empty_lookup_value; ?>'){ $j('.btn[id=courses_view_parent]').hide(); }else{ $j('.btn[id=courses_view_parent]').show(); }

						if(typeof(course_id_update_autofills__RAND__) == 'function') course_id_update_autofills__RAND__();
					}
				});
			}

		<?php }else{ ?>

			$j.ajax({
				url: 'ajax_combo.php',
				dataType: 'json',
				data: { id: AppGini.current_course_id__RAND__.value, t: 'enrollment', f: 'course_id' },
				success: function(resp){
					$j('[id=course_id-container__RAND__], [id=course_id-container-readonly__RAND__]').html('<span id="course_id-match-text">' + resp.results[0].text + '</span>');
					if(resp.results[0].id == '<?php echo empty_lookup_value; ?>'){ $j('.btn[id=courses_view_parent]').hide(); }else{ $j('.btn[id=courses_view_parent]').show(); }

					if(typeof(course_id_update_autofills__RAND__) == 'function') course_id_update_autofills__RAND__();
				}
			});
		<?php } ?>

		}
	</script>
	<?php

	$lookups = str_replace('__RAND__', $rnd1, ob_get_contents());
	ob_end_clean();


	// code for template based detail view forms

	// open the detail view template
	if($dvprint){
		$template_file = is_file("./{$TemplateDVP}") ? "./{$TemplateDVP}" : './templates/enrollment_templateDVP.html';
		$templateCode = @file_get_contents($template_file);
	}else{
		$template_file = is_file("./{$TemplateDV}") ? "./{$TemplateDV}" : './templates/enrollment_templateDV.html';
		$templateCode = @file_get_contents($template_file);
	}

	// process form title
	$templateCode = str_replace('<%%DETAIL_VIEW_TITLE%%>', 'Detail View', $templateCode);
	$templateCode = str_replace('<%%RND1%%>', $rnd1, $templateCode);
	$templateCode = str_replace('<%%EMBEDDED%%>', ($_REQUEST['Embedded'] ? 'Embedded=1' : ''), $templateCode);
	// process buttons
	if($AllowInsert){
		if(!$selected_id) $templateCode=str_replace('<%%INSERT_BUTTON%%>', '<button type="submit" class="btn btn-success" id="insert" name="insert_x" value="1" onclick="return enrollment_validateData();"><i class="glyphicon glyphicon-plus-sign"></i> ' . $Translation['Save New'] . '</button>', $templateCode);
		$templateCode=str_replace('<%%INSERT_BUTTON%%>', '<button type="submit" class="btn btn-default" id="insert" name="insert_x" value="1" onclick="return enrollment_validateData();"><i class="glyphicon glyphicon-plus-sign"></i> ' . $Translation['Save As Copy'] . '</button>', $templateCode);
	}else{
		$templateCode=str_replace('<%%INSERT_BUTTON%%>', '', $templateCode);
	}

	// 'Back' button action
	if($_REQUEST['Embedded']){
		$backAction = 'window.parent.jQuery(\'.modal\').modal(\'hide\'); return false;';
	}else{
		$backAction = '$$(\'form\')[0].writeAttribute(\'novalidate\', \'novalidate\'); document.myform.reset(); return true;';
	}

	if($selected_id){
		if(!$_REQUEST['Embedded']) $templateCode=str_replace('<%%DVPRINT_BUTTON%%>', '<button type="submit" class="btn btn-default" id="dvprint" name="dvprint_x" value="1" onclick="$$(\'form\')[0].writeAttribute(\'novalidate\', \'novalidate\'); document.myform.reset(); return true;" title="' . html_attr($Translation['Print Preview']) . '"><i class="glyphicon glyphicon-print"></i> ' . $Translation['Print Preview'] . '</button>', $templateCode);
		if($AllowUpdate){
			$templateCode=str_replace('<%%UPDATE_BUTTON%%>', '<button type="submit" class="btn btn-success btn-lg" id="update" name="update_x" value="1" onclick="return enrollment_validateData();" title="' . html_attr($Translation['Save Changes']) . '"><i class="glyphicon glyphicon-ok"></i> ' . $Translation['Save Changes'] . '</button>', $templateCode);
		}else{
			$templateCode=str_replace('<%%UPDATE_BUTTON%%>', '', $templateCode);
		}
		if(($arrPerm[4]==1 && $ownerMemberID==getLoggedMemberID()) || ($arrPerm[4]==2 && $ownerGroupID==getLoggedGroupID()) || $arrPerm[4]==3){ // allow delete?
			$templateCode=str_replace('<%%DELETE_BUTTON%%>', '<button type="submit" class="btn btn-danger" id="delete" name="delete_x" value="1" onclick="return confirm(\'' . $Translation['are you sure?'] . '\');" title="' . html_attr($Translation['Delete']) . '"><i class="glyphicon glyphicon-trash"></i> ' . $Translation['Delete'] . '</button>', $templateCode);
		}else{
			$templateCode=str_replace('<%%DELETE_BUTTON%%>', '', $templateCode);
		}
		$templateCode=str_replace('<%%DESELECT_BUTTON%%>', '<button type="submit" class="btn btn-default" id="deselect" name="deselect_x" value="1" onclick="' . $backAction . '" title="' . html_attr($Translation['Back']) . '"><i class="glyphicon glyphicon-chevron-left"></i> ' . $Translation['Back'] . '</button>', $templateCode);
	}else{
		$templateCode=str_replace('<%%UPDATE_BUTTON%%>', '', $templateCode);
		$templateCode=str_replace('<%%DELETE_BUTTON%%>', '', $templateCode);
		$templateCode=str_replace('<%%DESELECT_BUTTON%%>', ($ShowCancel ? '<button type="submit" class="btn btn-default" id="deselect" name="deselect_x" value="1" onclick="' . $backAction . '" title="' . html_attr($Translation['Back']) . '"><i class="glyphicon glyphicon-chevron-left"></i> ' . $Translation['Back'] . '</button>' : ''), $templateCode);
	}

	// set records to read only if user can't insert new records and can't edit current record
	if(($selected_id && !$AllowUpdate && !$AllowInsert) || (!$selected_id && !$AllowInsert)){
		$jsReadOnly .= "\tjQuery('#stud_id').prop('disabled', true).css({ color: '#555', backgroundColor: '#fff' });\n";
		$jsReadOnly .= "\tjQuery('#stud_id_caption').prop('disabled', true).css({ color: '#555', backgroundColor: 'white' });\n";
		$jsReadOnly .= "\tjQuery('#course_id').prop('disabled', true).css({ color: '#555', backgroundColor: '#fff' });\n";
		$jsReadOnly .= "\tjQuery('#course_id_caption').prop('disabled', true).css({ color: '#555', backgroundColor: 'white' });\n";
		$jsReadOnly .= "\tjQuery('#score').replaceWith('<div class=\"form-control-static\" id=\"score\">' + (jQuery('#score').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('.select2-container').hide();\n";

		$noUploads = true;
	}elseif($AllowInsert){
		$jsEditable .= "\tjQuery('form').eq(0).data('already_changed', true);"; // temporarily disable form change handler
			$jsEditable .= "\tjQuery('form').eq(0).data('already_changed', false);"; // re-enable form change handler
	}

	// process combos
	$templateCode=str_replace('<%%COMBO(stud_id)%%>', $combo_stud_id->HTML, $templateCode);
	$templateCode=str_replace('<%%COMBOTEXT(stud_id)%%>', $combo_stud_id->MatchText, $templateCode);
	$templateCode=str_replace('<%%URLCOMBOTEXT(stud_id)%%>', urlencode($combo_stud_id->MatchText), $templateCode);
	$templateCode=str_replace('<%%COMBO(course_id)%%>', $combo_course_id->HTML, $templateCode);
	$templateCode=str_replace('<%%COMBOTEXT(course_id)%%>', $combo_course_id->MatchText, $templateCode);
	$templateCode=str_replace('<%%URLCOMBOTEXT(course_id)%%>', urlencode($combo_course_id->MatchText), $templateCode);

	/* lookup fields array: 'lookup field name' => array('parent table name', 'lookup field caption') */
	$lookup_fields = array(  'stud_id' => array('students', 'Student'), 'course_id' => array('courses', 'Course'));
	foreach($lookup_fields as $luf => $ptfc){
		$pt_perm = getTablePermissions($ptfc[0]);

		// process foreign key links
		if($pt_perm['view'] || $pt_perm['edit']){
			$templateCode = str_replace("<%%PLINK({$luf})%%>", '<button type="button" class="btn btn-default view_parent hspacer-md" id="' . $ptfc[0] . '_view_parent" title="' . html_attr($Translation['View'] . ' ' . $ptfc[1]) . '"><i class="glyphicon glyphicon-eye-open"></i></button>', $templateCode);
		}

		// if user has insert permission to parent table of a lookup field, put an add new button
		if($pt_perm['insert'] && !$_REQUEST['Embedded']){
			$templateCode = str_replace("<%%ADDNEW({$ptfc[0]})%%>", '<button type="button" class="btn btn-success add_new_parent hspacer-md" id="' . $ptfc[0] . '_add_new" title="' . html_attr($Translation['Add New'] . ' ' . $ptfc[1]) . '"><i class="glyphicon glyphicon-plus-sign"></i></button>', $templateCode);
		}
	}

	// process images
	$templateCode=str_replace('<%%UPLOADFILE(rec_id)%%>', '', $templateCode);
	$templateCode=str_replace('<%%UPLOADFILE(stud_id)%%>', '', $templateCode);
	$templateCode=str_replace('<%%UPLOADFILE(course_id)%%>', '', $templateCode);
	$templateCode=str_replace('<%%UPLOADFILE(score)%%>', '', $templateCode);
	$templateCode=str_replace('<%%UPLOADFILE(notes)%%>', '', $templateCode);
	$templateCode=str_replace('<%%UPLOADFILE(certificate_notes)%%>', '', $templateCode);

	// process values
	if($selected_id){
		$templateCode=str_replace('<%%VALUE(rec_id)%%>', html_attr($row['rec_id']), $templateCode);
		$templateCode=str_replace('<%%URLVALUE(rec_id)%%>', urlencode($urow['rec_id']), $templateCode);
		$templateCode=str_replace('<%%VALUE(stud_id)%%>', html_attr($row['stud_id']), $templateCode);
		$templateCode=str_replace('<%%URLVALUE(stud_id)%%>', urlencode($urow['stud_id']), $templateCode);
		$templateCode=str_replace('<%%VALUE(course_id)%%>', html_attr($row['course_id']), $templateCode);
		$templateCode=str_replace('<%%URLVALUE(course_id)%%>', urlencode($urow['course_id']), $templateCode);
		$templateCode=str_replace('<%%VALUE(score)%%>', html_attr($row['score']), $templateCode);
		$templateCode=str_replace('<%%URLVALUE(score)%%>', urlencode($urow['score']), $templateCode);
		if($AllowUpdate || $AllowInsert){
			$templateCode = str_replace('<%%HTMLAREA(notes)%%>', '<textarea name="notes" id="notes" rows="5">' . html_attr($row['notes']) . '</textarea>', $templateCode);
		}else{
			$templateCode = str_replace('<%%HTMLAREA(notes)%%>', '<div id="notes" class="form-control-static">' . $row['notes'] . '</div>', $templateCode);
		}
		$templateCode=str_replace('<%%VALUE(notes)%%>', nl2br($row['notes']), $templateCode);
		$templateCode=str_replace('<%%URLVALUE(notes)%%>', urlencode($urow['notes']), $templateCode);
		if($AllowUpdate || $AllowInsert){
			$templateCode = str_replace('<%%HTMLAREA(certificate_notes)%%>', '<textarea name="certificate_notes" id="certificate_notes" rows="5">' . html_attr($row['certificate_notes']) . '</textarea>', $templateCode);
		}else{
			$templateCode = str_replace('<%%HTMLAREA(certificate_notes)%%>', '<div id="certificate_notes" class="form-control-static">' . $row['certificate_notes'] . '</div>', $templateCode);
		}
		$templateCode=str_replace('<%%VALUE(certificate_notes)%%>', nl2br($row['certificate_notes']), $templateCode);
		$templateCode=str_replace('<%%URLVALUE(certificate_notes)%%>', urlencode($urow['certificate_notes']), $templateCode);
	}else{
		$templateCode=str_replace('<%%VALUE(rec_id)%%>', '', $templateCode);
		$templateCode=str_replace('<%%URLVALUE(rec_id)%%>', urlencode(''), $templateCode);
		$templateCode=str_replace('<%%VALUE(stud_id)%%>', '', $templateCode);
		$templateCode=str_replace('<%%URLVALUE(stud_id)%%>', urlencode(''), $templateCode);
		$templateCode=str_replace('<%%VALUE(course_id)%%>', '', $templateCode);
		$templateCode=str_replace('<%%URLVALUE(course_id)%%>', urlencode(''), $templateCode);
		$templateCode=str_replace('<%%VALUE(score)%%>', '', $templateCode);
		$templateCode=str_replace('<%%URLVALUE(score)%%>', urlencode(''), $templateCode);
		$templateCode=str_replace('<%%HTMLAREA(notes)%%>', '<textarea name="notes" id="notes" rows="5"></textarea>', $templateCode);
		$templateCode=str_replace('<%%HTMLAREA(certificate_notes)%%>', '<textarea name="certificate_notes" id="certificate_notes" rows="5"></textarea>', $templateCode);
	}

	// process translations
	foreach($Translation as $symbol=>$trans){
		$templateCode=str_replace("<%%TRANSLATION($symbol)%%>", $trans, $templateCode);
	}

	// clear scrap
	$templateCode=str_replace('<%%', '<!-- ', $templateCode);
	$templateCode=str_replace('%%>', ' -->', $templateCode);

	// hide links to inaccessible tables
	if($_REQUEST['dvprint_x'] == ''){
		$templateCode .= "\n\n<script>\$j(function(){\n";
		$arrTables = getTableList();
		foreach($arrTables as $name => $caption){
			$templateCode .= "\t\$j('#{$name}_link').removeClass('hidden');\n";
			$templateCode .= "\t\$j('#xs_{$name}_link').removeClass('hidden');\n";
		}

		$templateCode .= $jsReadOnly;
		$templateCode .= $jsEditable;

		if(!$selected_id){
		}

		$templateCode.="\n});</script>\n";
	}

	// ajaxed auto-fill fields
	$templateCode .= '<script>';
	$templateCode .= '$j(function() {';


	$templateCode.="});";
	$templateCode.="</script>";
	$templateCode .= $lookups;

	// handle enforced parent values for read-only lookup fields

	// don't include blank images in lightbox gallery
	$templateCode = preg_replace('/blank.gif" data-lightbox=".*?"/', 'blank.gif"', $templateCode);

	// don't display empty email links
	$templateCode=preg_replace('/<a .*?href="mailto:".*?<\/a>/', '', $templateCode);

	/* default field values */
	$rdata = $jdata = get_defaults('enrollment');
	if($selected_id){
		$jdata = get_joined_record('enrollment', $selected_id);
		$rdata = $row;
	}
	$cache_data = array(
		'rdata' => array_map('nl2br', array_map('addslashes', $rdata)),
		'jdata' => array_map('nl2br', array_map('addslashes', $jdata)),
	);
	$templateCode .= loadView('enrollment-ajax-cache', $cache_data);

	// hook: enrollment_dv
	if(function_exists('enrollment_dv')){
		$args=array();
		enrollment_dv(($selected_id ? $selected_id : FALSE), getMemberInfo(), $templateCode, $args);
	}

	return $templateCode;
}
?>